/* LMI/lmi06/ALGOGEOM/TD/TPtriang/MYTRIANG/triang.c */
/*--------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <assert.h>
#include "triang.h"

/* ------------------VARIABLES GLOBALES -----------------------*/

int NP=0;                   /* nombre de points                */
Point *POLYG[NPMAX];        /* tableau des sommets du polygone */
Point *DIAG[NDMAX];         /* tableau des diagonales          */
dliste_points PTS=NULL;     /* d-liste des Point               */
int xmin,xmax,ymin,ymax;    /* coordonnees extremes            */

/* ---------------------FONCTIONS -----------------------------*/

/* ALLOCATION MEMOIRE */
Point *Palloc(void)
{ return((Point *)malloc(sizeof(Point)));}
cell *caloc(void)
{ return((cell *)malloc(sizeof(cell)));}
int *ialloc(void)
{ return((int *)malloc(sizeof(int)));}

/* d-LISTES */
void ajouter(dliste_points *L, cell *p, Point *P)
{ cell *q=caloc();
  q->val=P;
  if(*L==NULL)
    /* creation d'une liste de longueur 1 */
    {q->prec=q;
     q->suiv=q;
     *L=q;}
  else
    /* insertion d'une nouvelle cellule */
    /* p est suppose non nul            */
    {q->prec=p;
      q->suiv=p->suiv;
      q->prec->suiv=q;
      q->suiv->prec=q;}}

void supprimer(dliste_points *L, cell *p)
{if (p->prec== p)
    {*L=NULL;}
  else
    {p->prec->suiv=p->suiv;
     p->suiv->prec=p->prec;
     if (p==*L) *L=(*L)->suiv;
     }}

/* ENTREES-SORTIES */
void lire_points( void )
{ int n = 0;
  cell *ccour=caloc();
  Point *Pcour;
  int *xtemp=ialloc(); 
  int *ytemp=ialloc();
    printf("%%");printf("donnez-moi des points, au plus %3d \n",NPMAX); 
    while (( n < NPMAX) && (scanf("%d %d",xtemp,ytemp) != EOF))
     { Pcour=Palloc();
       Pcour->x= *xtemp;
       Pcour->y= *ytemp;
       POLYG[n]=Pcour;
       ajouter(&PTS,ccour,Pcour);
       ++n;
       ccour=PTS->prec;}
   {if (n < NPMAX) 
       {NP=n; printf("%%");printf("%3d points lus\n",n); }
     else
       {printf("%%");printf("%3d points lus; nombre max est atteint;\n les autres points ne seront pas lus \n",n);}}}


void ecrire_points(void)
{int n=0;cell *ccour=PTS;
  printf("%%");printf("Liste des points \n");
    while ( n < NP)
      {printf("%%");printf("(%d,%d)\n",ccour->val->x,ccour->val->y);
	ccour=ccour->suiv;
	n++;}}

void ecrire_points_inverse(void)
{int n=0;cell *ccour=PTS->prec;
  printf("%%");printf("Liste des points \n");
    while ( n < NP)
      {printf("%%");printf("(%d,%d)\n",ccour->val->x,ccour->val->y);
	ccour=ccour->prec;
	n++;}}

/* GEOMETRIE */
int det(Point *p1, Point *p2)       /* determinant */
{return((p1->x * p2->y)-(p1->y * p2->x));}

int direct(Point *p1, Point *p2, Point *p3) 
{Point *u= Palloc();Point *v=Palloc();
  u->x= p2->x - p1->x; u->y= p2->y - p1->y;
  v->x= p3->x - p2->x; v->y= p3->y - p2->y;
  if (det(u,v) > 0) return(1);
  else return(0);
  free(u);free(v);}

/* ---------------------ALGO ---------------------*/
/* Lire les points                                */
/* trianguler:                                    */
/*     calculer les oreilles                      */
/*     boucle de suppression des oreilles         */
/* Abscisses et ordonnees extremes                */
/* Generer le postscript                          */
/* -----------------------------------------------*/

int main()
{ 
  lire_points();
  ecrire_points();
  return(EXIT_SUCCESS);
}


